#!/usr/bin/perl -T
# $Id: iv_setup.cgi,v 1.27 2015/01/20 13:20:52 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2011              ###
###                                                      ###
############################################################
############################################################


use strict;
use warnings;
use CGI qw(:standard :netscape);
use RFC::Main;
use RFC::Rig;
use RFC::RFCCGI qw(:cgi :html);
use RFC::Header;
use SemaforeFile;

my $acmode = get_cv('global','access_mode');
$acmode = 'celltest' unless ($acmode);
my $r = param('rig');
unless ($r)
{
    print header();
    print "No rig specified!\n";
    exit;
}
my $rig = RFC::Rig->new($r);

my $usermode = user_auth($acmode,'c');
$usermode = 1 if (RFC::RFCCGI::rig_mode());
my $modifymode = user_auth($acmode,'m'); 
$modifymode = rig_cert() if (RFC::RFCCGI::rig_mode());
if (RFC::RFCCGI::rig_mode())
{
    ####  Read and use mode deprecated after initialisation of rig authentification ####
    $usermode = 1;
}
####
unless (RFC::RFCCGI::rig_auth())
{
    $usermode = 0;
    $modifymode = 0;
}
unless ($modifymode)
{
    $modifymode = RFC::Main::passwd_client('isadmin',get_id());
}

if (!defined(param))
{
    &print_header("Please log in to the $name");
    print '<center>';
    RFC::RFCCGI::login();
    print '</center>';
    &print_end;
}
else
{
    #### husk at aendre accessparameter til det relevante for scriptet!! ####
    if ((login_ok()) && (RFC::RFCCGI::rig_auth()) && $usermode)
    { 
        &print_header("i-V curve setup for rig ".$rig->name);
        print RFC_start_html(-title=>"i-V curve setup for ".$rig->name, -style=>{src=>'/celltest/RFCcontrol.css'});
        top_nav_bar_start;
	top_no_button;
	top_no_button;
	if ($modifymode)
	{
	    top_nav_bar_button('','calibration','','Setup thermocouple calibration','s1','rig,'.$rig->name.',1');
	}
	else
	{
	    top_no_button;
	}
	tab_newrow;
	&js_back();
	top_js_return('#006600','white');
	if ($modifymode)
	{
	    top_nav_bar_button('rig_conf.cgi','','','Manual configuration','s1','rig,'.$rig->name.',1');
	}
	else
	{
	    top_no_button;
	}
	if ($modifymode || $usermode)
	{
	    top_nav_bar_button('rig_setup.cgi','','','Rig '.$rig->name.' configuration','s2','rig,'.$rig->name.',1');
	}
	else
	{
	    top_no_button;
	}
	top_nav_bar_button('rig_main.cgi','','','To rig'.$rig->name.' main page','s3','rig,'.$rig->name.',1');
	top_nav_bar_button('main.cgi','','','To menu','s4');
	end_top_bar;
        param(-name=>'action',-value=>'')  unless (defined(param('action')));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    /^delete$/ and do {&delete(); &calibration; last CASE;};
	    /^save$/ and do {&save(); &calibration; last CASE;};
	    /^calibration/ and do {&calibration; last CASE;};
	    /^Set values$/ and do {&save; last CASE;};
	    ### Default response ####
    	    &insert_data_form;
	}	
	print_end;
    }
    else 
    {
	&not_auth;
    }
}
    
exit;

sub delete()
{
    return unless (is_admin());
    my $filename = get_CGI_value('filelist');
    if ($filename =~ /^([\w\.\-]+)$/)
    {
	my $fn = $1;
	eval {
	    my $f1 = $homedir.'convert-tables/userfiles/'.$fn;
	    unlink($f1) if (-e $f1);
	    my $f2 = $homedir.'convert-tables/mv_to_temp/'.$fn;
	    unlink($f1) if (-e $f1);
	    my $f3 = $homedir.'convert-tables/temp_to_mv/'.$fn;
	    unlink($f1) if (-e $f1);	
	};
	if ($@)
	{
	    print h1({-class=>'Alert'},$@);
	}
    }
}


sub save()
{
    my $filename = get_CGI_value('filename');
    if ($filename =~ /^([\w\.\-]+)$/)
    {
	my $fn = $homedir.'convert-tables/userfiles/'.$1;
	my $file = SemaforeFile->new($fn);
	$file->writeline(get_CGI_value('new_file'));
    }
}

sub calibration()
{
    my @list = RFC::Main::spline_user_files();
    unshift @list,'';
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr height=1>';
    print '<td width="10%"></td>';
    print '<td width="30%"></td>';
    print '<td width="20%"></td>';
    print '<td width="30%"></td>';
    print '<td width="10%"></td>';
    print '</tr>';
    print '<tr><td colspan=5 class=heading height=50> Thermocouple calibration files </td></tr>';
    print '<tr><td></td><th> Current files </th><td></td><th> New file </th></tr>',"\n";
    print start_form(-name=>'sofc',-onsubmit=>'return check_file()');
    print_hidden_rig();
    print hidden(-name=>'action',-value=>'',-force=>1);
    print '<tr><td></td><td>';
    print popup_menu(-name=>'filelist',-values=>[@list],-class=>'textfield',-default=>'',-force=>1,-onchange=>'change_val(this)');
    print '</td><td></td><td>';
    print textfield(-name=>'filename',-value=>'Filename for new file (must be changed)',-onchange=>'set_filename_ok()',-class=>'textfield');
    print '</td></tr>';
    print '<tr><td></td><td>';
    print textarea(-name=>'current_file',-value=>'',-force=>'1',-class=>'textfield',-rows=>20);
    print '</td><td></td><td>';
    print textarea(-name=>'new_file',-value=>'',-force=>'1',-class=>'textfield',-rows=>20);
    print '</td></tr>';
    print '<tr><td></td><td>';
    print button(-name=>'dummy',-value=>'Delete file',-class=>'hidden',-id=>'delbtn',-onclick=>'confirm_delete()');
    print '</td><td></td><td>';
    print button(-name=>'dummy2',-value=>'Save new file',-class=>'hidden',-id=>'savebtn',-onclick=>'confirm_save()');
    print end_form();
    print '</table>';
    my $admin = 'false';
    $admin = 'true' if (is_admin());
    print <<END;

<script language="javascript">

var filenameok = false;
var admin = $admin

function check_file()
{
    if (!filenameok)
    {
	alert('Filename not entered');
	return false;
    }
    if (document.sofc.new_file.value.length < 10)
    {
	alert('You must input a calibration file');
	return false;
    }
    return true;
}

function confirm_save()
{
    if (filenameok)
    {
	if (document.sofc.new_file.value.length < 10)
	{
	    alert('You must input a calibration file');
	    return false;
	}
	document.sofc.action.value = 'save';
	document.sofc.submit();	
    }
}

function confirm_delete()
{
    if (confirm('Delete this file'))
    {
	document.sofc.action.value = 'delete';
	document.sofc.submit();
    }
}

function set_filename_ok()
{
    var reg = /^[\\w\\-\\.]+\$/;
    var btn = document.getElementById('savebtn');
    if (!reg.test(document.sofc.filename.value))
    {
	btn.setAttribute("class","hidden");
	btn.setAttribute("className","hidden");	    
	filenameok = false;
	alert("Illegal filename attempted, only alphanumerics , '-' and '.' are allowed");
    }
    else
    {
	btn.setAttribute("class","s0");
	btn.setAttribute("className","s0");
	filenameok = true;
    }
}

function change_val(i)
{
    run_ajax('rig_ajax_run.cgi','&action=get_callibration_file&filename='+i.value,set_file);
}



function set_file(r)
{
    document.sofc.current_file.value = r;
    if (admin)
    {
	var btn = document.getElementById('delbtn');
	if (r == "")
	{
	    btn.setAttribute("class","hidden");
	    btn.setAttribute("className","hidden");	    
	}
	else
	{
	    btn.setAttribute("class","s0");
	    btn.setAttribute("className","s0");
	}
    }
    if (r != "")
    {
	i = document.sofc.filelist.value;
	run_ajax('rig_ajax_run.cgi','&action=plot_callibration_file&filename='+i,show_plot);
    }
}


function show_plot(r)
{
    RFC_open('../../'+r,500,400,300,200);
}

</script>

END

}



sub insert_data_form
{
    print '<table border=0 cellspacing=5 cellpadding=0 style="width:100%"><tr height=1>';
    print '<td width="5%"></td>';
    print '<td width="20%"></td>';
    print '<td width="25%"></td>';
    print '<td width="20%"></td>';
    print '<td width="5%"></td>';
    print '<td width="5%"></td>';
    print '<td width="15%"></td>';
    print '<td width="5%"></td>';
    print '</tr>';
    print '<tr><td colspan=8 class=heading height=50> i-V curve setup for rig ',$rig->name,'</td></tr>';
    my $clabel = $rig->get_cv('IV_control','current_label');
    my $vlabel = $rig->get_cv('IV_control','voltage_label');
    my $tlabel = $rig->get_cv('IV_control','temp_label');
    my @clabels = $rig->list_devices('simplechannel');
    my @vlabels = $rig->list_devices('simplechannel');
    my @tlabels = $rig->list_devices('templog');
    my $step1 = $rig->get_cv('IV_control','currentstep1');
    my $step2 = $rig->get_cv('IV_control','currentstep2');
    my $step3 = $rig->get_cv('IV_control','currentstep3');
    my $climit = $rig->get_cv('IV_control','currentlimit');
    my $vlimit = $rig->get_cv('IV_control','voltagelimit_iv');
    my $elimit = $rig->get_cv('IV_control','electrolysis_limit_voltage');
    my $pause = $rig->get_cv('IV_control','ivpause');
    my $pvhOCV = $rig->get_cv('IV_control','OCV_measure_number');
    my $errorlimit = $rig->get_cv('IV_control','diff_current_limit');
    my $mincurrent = get_cv('iVcurves','minimum_current_step');
    my $cache = $rig->get_cv('IV_control','allow_caching');
    $cache = 'No' unless ($cache);
    $mincurrent = 0.05 unless ($mincurrent);
    print start_form(-name=>'sofc',-class=>"form",-onsubmit=>'return checkinput()');
    &print_hidden_rig;
    #### Inputside #####
    print '<tr><td></td><td colspan=2 rowspan=14>';
    print '<img src="/celltest/logfilenew.png">';
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Current measuring simple channel:';
    print '</th><td colspan=2>';
    print popup_menu(-name=>'current_label',-values=>['',@clabels],-class=>'textfield',-default=>$clabel,-force=>1,-onchange=>'change_val(this)',-id=>'current_label');
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Voltage measuring simple channel:';
    print '</th><td colspan=2>';
    print popup_menu(-name=>'voltage_label',-values=>['',@vlabels],-class=>'textfield',-default=>$vlabel,-force=>1,-onchange=>'change_val(this)',-id=>'voltage_label');
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Temperature log device:';
    print '</th><td colspan=2>';
    print popup_menu(-name=>'temp_label',-values=>['',@tlabels],-class=>'textfield',-default=>$tlabel,-force=>1,-onchange=>'change_val(this)',-id=>'temp_label');
    print '</td></tr>';



    print '<tr><td></td><th>';
    print 'Current step 1:';
    print '</th><td>';
    print textfield(-name=>'currentstep1',-id=>'currentstep1',-value=>$step1,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');
    print '</td><th> A </th><td>(min '.$mincurrent.', max 1)';
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Current step 2:';
    print '</th><td>';
    print textfield(-name=>'currentstep2',-id=>'currentstep2',-value=>$step2,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');
    print '</td><th> A </th><td>(min '.$mincurrent.', max 3)';
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Current step 3:';
    print '</th><td>';
    print textfield(-name=>'currentstep3',-id=>'currentstep3',-value=>$step3,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');
    print '</td><th> A </th><td>(min '.$mincurrent.', max 0.5)';
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Current limit:';
    print '</th><td>';
    my $miniv = get_cv('iVcurves','minimum_cell_voltage_for_iv');
    my $maxiv = get_cv('iVcurves','maximum_cell_voltage_for_iv');
    $maxiv = 2000 unless ($maxiv);
    $miniv = 0 unless ($miniv);
    $maxiv -= 25;
    $miniv += 25;
    my $maxi = get_cv('iVcurves','current_limit');
    $maxi = 40 unless (defined($maxi));
    $maxi = 0.05 unless ($maxi > 0.05);
    my $mini = 0.05;
    my @list = $rig->list_devices_control('PSU');
    foreach (@list)
    {
	my $d = $rig->get_device('PSU',$_);
	$maxi = $d->maxcurrent() if ($d->maxcurrent < $maxi);
	$miniv = $d->minvoltage()*1000 if ($d->minvoltage() * 1000 > $miniv);
	$maxiv = $d->maxvoltage()*1000 if ($d->maxvoltage() * 1000 < $maxiv);
    }
    print textfield(-name=>'currentlimit',-id=>'currentlimit',-value=>$climit,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');
    print "</td><th> A </th><td>(min $mini, max $maxi)";
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Voltage limit (FC mode):';
    print '</th><td>';
    print textfield(-name=>'voltagelimit_iv',-id=>'voltagelimit_iv',-value=>$vlimit,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');

    print '</td><th> mV </th><td>(min '.xss($miniv).', max '.xss($maxiv).')';
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Voltage limit (EC mode):';
    print '</th><td>';
    print textfield(-name=>'electrolysis_limit_voltage',-id=>'electrolysis_limit_voltage',-value=>$elimit,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');
    print '</td><th> mV </th><td>(min '.xss($miniv).', max '.xss($maxiv).')';
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'Time between steps:';
    print '</th><td>';
    print textfield(-name=>'ivpause',-id=>'ivpause',-value=>$pause,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');
    print '</td><th> s </th><td>(min 1, max 1000)';
    print '</td></tr>';
    print '<tr><td></td><th>';
    print 'OCV measurements (start and end):';
    print '</th><td>';
    print textfield(-name=>'OCV_measure_number',-id=>'OCV_measure_number',-value=>$pvhOCV,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');
    print '</td><th></th><td>(min 2, max 10)</td></tr>';
    print '<tr><td></td><th>';
    print 'Current error limit:';
    print '</th><td>';
    print textfield(-name=>'diff_current_limit',-id=>'diff_current_limit',-value=>$errorlimit,-force=>'1',-class=>'textfield',-onchange=>'change_val(this)');
    print '</td><th> A';
#    @list = ();
#    foreach my $item ($rig->list_caching())
#    {
#	push @list,$item->type.':'.$item->name;
#    }
#    print '<td rowspan=2>';
#    print 'List of caching devices<br>';
#    print textarea(-name=>'cash_list',-value=>join("\n",@list),-rows=>2,-class=>'textfield');
    print '</th></tr>';
    print '<tr><td></td><th>';
    print 'Allow caching durring i-V curves:';
    print '</th><td colspan=1>';
    print popup_menu(-name=>'allow_caching',-values=>['No','Yes'],-class=>'textfield',-default=>$cache,-force=>1,-onchange=>'change_val(this)',-id=>'allow_caching');
    print '</td><td></td><td>';
    print button(-name=>'show_caching',-label=>'Show list of caching devices',-class=>'s3',-onclick=>"run_ajax('rig_ajax_run.cgi','&action=list_caching',alert)");
    print '</td></tr>';
    print '<tr><td></td><td>';
    print '</td><td colspan=3>';
    print '</td></tr>';
    print end_form();
    print start_form(-class=>'form',-action=>'rig_main.cgi');
    &print_hidden();
    print '<tr><td colspan=3></td><td>';
    print '</td><td colspan=3>';
    if ($rig->is_iv)
    {
#	print button(-name=>'dummym',-value=>'Stop running iV curve',-class=>'s1',-OnClick=>"stop_iv()");
    }
    else
    {
#	print button(-name=>'dummym',-value=>'Start iV curve',-class=>'s1',-OnClick=>"run_ajax('rig_ajax_run.cgi','&action=start_iv',set_temp_ok)");
    }
    print '</td></tr>';
    print end_form();
    print '</table>';
    print <<END;

<script language="javascript">

function stop_iv()
{
    var ok = confirm("Stop running iV curve?");
    if (ok)
    {
        run_ajax('rig_ajax_run.cgi','&action=stop_iv',set_temp_ok);
    }
}

function set_temp_ok(t)
{
    alert(t);
    /* Sumbit the login info to reset logout timer */
	document.login_info.submit();
}

function set_val(res)
{
    var arr = res.split("\\n");
    if (arr[0] == "OK" || arr[0] == "WARN")
    {
        if (arr[0] == "WARN")
        {
            alert(arr[3]);
        }
        var obj = document.getElementById(arr[1]);
        obj.disabled = false;
        obj.value = arr[2];
    }
    else
    {
        alert(arr[0]);
    }
}

function change_val(element)
{
    var n = element.name;
    var val = element.value;
    element.disabled = true;
    run_ajax('change_config.cgi','&action=change_config_value&section=IV_control&key='+n+'&value='+val,set_val);
}

</script>

END



}    

